/***************************************************************************
                          attributes.cpp  -  description
                             -------------------
    begin                : Sun Dec 16 2001
    copyright            : (C) 2001-2002 by Anthony Liekens
    email                : mooby@nerdhero.org
    Modified by          : Walter Schreppers
    email                : wschrep@uia.ac.be

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "attributes.h"

Attributes::Attributes() {
}

Attributes::~Attributes() {
}

void
Attributes::addAttributes( ElementNode* sub, bool overwrite ) {
	for( unsigned int i = 0; i < sub->attributes.size(); i++ ) {
    Attribute attr= sub->attributes[i];
    if( overwrite )
      (*this)[attr.name] = attr.value;
    else
      if( !keyExists( attr.name ) )
        (*this)[attr.name] = attr.value;
	}
}

void
Attributes::printOn( ostream& os ) {
	for( iterator i = begin(); i != end(); i++ ) {
		os << i->first << "->" << i->second << endl;
	}
}

string
Attributes::apply( const string& ori ) {
	string res = ori;
	for( iterator i = begin(); i != end(); i++ ) {

    //res.replace( QRegExp( "$" + i->first + ";" ), i->second );
    
    string var="$"+i->first+";";
    unsigned int pos=res.find(var);
    if(pos!=string::npos)
      res.replace(pos,var.length(),i->second );	
    
	}
	return res;
}

bool
Attributes::keyExists( const string& key ) {
	for( iterator i = begin(); i != end(); i++ ) {
		if( i->first == key )
			return true;
	}
	return false;
}


