/***************************************************************************
                          converter.cpp  -  description
                             -------------------
    begin                : Sat Dec 8 2001
    copyright            : (C) 2001-2002 by Anthony Liekens
    email                : mooby@nerdhero.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "converter.h"
#include "Timer.h"
#include "../config.h"

Converter::Converter( const string& inputFile ){
	string fileName = inputFile;
	if( ( inputFile[0] != '/' ) && ( inputFile[0] != '~' ) )
		fileName = "./" + fileName;
	doc = new BaseMLDocument( fileName );
	quietMode = false;
}

Converter::~Converter() {
	delete doc;
}

void
Converter::convert( ostream& os ) {
	Timer t;
	if( !quietMode )
		os << "<!-- Generated with BaseML v" << VERSION << " -->" << endl;
	Stack callers;
	Attributes attributes;
	BaseMLDocument::defines.global( "COMPILER" );
	doc->execute( os, "main", NULL, callers, attributes );
	float time = t.elapsedTime( Timer::VIRTUAL );
	if( time < 0.001 )
		time = 0;
	os << endl;
	if( !quietMode )
		os << "<!-- Generated in " << time << " (virtual) seconds -->" << endl;
}
