/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Sat Dec  8 13:38:12 CET 2001
    copyright            : (C) 2001-2002 by Anthony Liekens
    email                : mooby@nerdhero.org
    Modified by          : Walter Schreppers
    email                : wschrep@uia.ac.be

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "converter.h"

#include "options.h"

#include "stack.h"

#include "../config.h"

#include <iostream>
#include <fstream>
#include <stdlib.h>

int main(int argc, char *argv[])
{
	Options options;
	
	options.setExtras( true, "file", 2, 0 );
	
	options.push_back( Option( "quiet", "Quiet mode; do not print XML comments" ) );
	options.push_back( Option( "help", "Print this help" ) );
	options.push_back( Option( "version", "Prints version information and exits" ) );
	
	vector<string> params = options.parse( argc, argv );
	
	if( options.optionGiven( "version" ) ) {
		cout << "BaseML v" << VERSION << endl;
	} else if( options.optionGiven( "help" ) ) {
	
		options.printUsage( cout, argv[0] );
		cout << "first required file is input file" << endl << "second file is output file" << endl;
		
	} else {
	
		if( params.size() == 0 ) {
			options.printUsage( cout, argv[0] );
		} else {
	
			Converter baseml( params[0] );
			
			if( options.optionGiven( "quiet" ) ) {
				baseml.setQuietMode( true );
			}
			
			if( params.size() == 1 ) {
				baseml.convert( cout );
			} else {
				ofstream of( params[1].c_str() );
				baseml.convert( of );
				of.close();
			}
			
		}
		
	}
	
}


