/***************************************************************************
                          stack.h  -  description
                             -------------------
    begin                : Tue Dec 11 2001
    copyright            : (C) 2001-2002 by Anthony Liekens
    email                : mooby@nerdhero.org
    Modified by          : Walter Schreppers
    email                : wschrep@uia.ac.be

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef STACK_H
#define STACK_H


/**
  *@author Anthony Liekens
  */

#include <stack>
#include <iostream>
#include "elementnode.h"

/*	// Example usage of Stack
	Stack s1;
	QDomDocument doc("doc");
	QDomElement* e1 = new QDomElement( doc.createElement( "element1" ) );
	QDomElement* e2 = new QDomElement( doc.createElement( "element2" ) );
	QDomElement* e3 = new QDomElement( doc.createElement( "element3" ) );
	s1.push( e1 );
	s1.push( e2 );
	cerr << s1.top()->tagName() << endl;
	s1.pop();
	
	Stack s2( s1, e3 );
	cerr << s2.top()->tagName() << endl;
*/
	


class Stack : public stack<ElementNode*>{
public:
	Stack();
	Stack( const Stack& );
	Stack( const Stack&, ElementNode* newPush );
	~Stack();
	
	void print( ostream& os );
};

#endif
